#!/bin/bash
BASED=$(dirname "$0")
yttaFile="$BASED"/Security.txt
Chermodsc="$(realpath "$0")"
run_game() {
    id=($(cmd package dump "$game_package" | awk '/MAIN/{getline; print $2}'))
    if [ -n "$id" ]; then
        am start -n "${id[0]}" &
        am kill "$game_package"
    else
        echo "Failed to find MAIN activity for $game_package"
    fi
    sleep 0.5
    echo ""
    echo " Please wait . . . ."
}
game_package="$1"
Aldo() {
ytta=$(cat $yttaFile)
}
Sc() {
echo "This script has been modified!" && sleep 0.5
echo "Security by @Chermodsc" && sleep 1 && am start -a android.intent.action.VIEW -d https://t.me/ChermodzsModule > /dev/null 2>&1 && exit 1
}

if [ -z "$game_package" ]; then
echo "Error: Game package not provided. Please enter the game package as an argument." && exit 1
else
display_info=$(dumpsys display)
fps=$(echo "$display_info" | grep -oE 'fps=[0-9.]+' | awk -F '=' '{printf "%d\n", $2+0}' | head -n 1)

Aldo
ytta2=$(sha256sum "$Chermodsc" | awk '{ print $1 }')
if [ "$ytta" != "$ytta2" ]; then
Sc
else
Install() {
echo " [ ꪶꫂ ] Installing X - BOOST 5.0"
sleep 1
apply
echo ""
echo ""
echo " [ • ] Applying code for game $game_package"
game
sleep 1
echo " [ꪶ✔ꫂ] Successfully Installed X - BOOST 5.0"
}

game() {
        device_config delete game_overlay "$game_package"
        device_config put game_overlay "$game_package" mode=2,renderer=vulkan,downscaleFactor=0.7,fps=$fps
        device_config put game_overlay "$game_package" mode=2,fps=$fps,downscaleFactor=0.7
        cmd game set --mode performance --downscale 0.7 --fps $fps --user 0 "$game_package"
        cmd shortcut reset-throttling "$game_package"
        cmd package compile -m quicken -f "$game_package"
        cmd power set-fixed-performance-mode-enabled true
        cmd power set-adaptive-power-saver-enabled false
        am force-stop "$game_package"
        cmd device_config put game_overlay "$game_package" mode=2,renderer="$renderer",downscaleFactor=0.7,fps=$fps
        cmd package compile -m quicken -f "$game_package"
        cmd shortcut reset-throttling "$game_package"
        cmd thermalservice override-status 0
        cmd game mode 2 "$game_package"
        cmd activity kill-all
}

Dvice() {
echo " [ Info Device ]"
echo ""
echo "• ID Device    » $(getprop ro.product.model)"
sleep 1
echo "• ID Brand     » $(getprop ro.product.system.brand)"
sleep 1
echo "• ID Version   » $(getprop ro.build.version.release)"
sleep 1
echo "• ID Model     » $(getprop ro.build.product)"
sleep 1
echo "• ID Chipset   » $(getprop ro.product.board)"
sleep 1
echo "• ID Gpu       » $(getprop ro.hardware.egl)"
sleep 1
echo "• ID Cpu       » $(getprop ro.hardware)"
sleep 1
echo "• ID Kernel    » $(uname -r)"
}

set_system_props() {
    props=(
        "debug.egl.hw 0"
        "debug.sf.hw 0"
        "debug.sf.latch_unsignaled 1"
        "debug.egl.swapinterval 0"
        "debug.sf.disable_client_composition_cache 1"
        "debug.gr.numframebuffers 5"
        "debug.gpu.rendering.framebuffer 2"
        "debug.composition.type gpu"
        "debug.hwui.renderer vulkan"
        "debug.sf.high_fps_early_gl_phase_offset_ns 8900000"
        "debug.sf.high_fps_early_phase_offset_ns 7500000"
        "debug.sf.high_fps_early_phase_offset_ns 6100000"
        "debug.sf.high_fps_early_gl_phase_offset_ns 650000"
        "debug.sf.high_fps_late_app_phase_offset_ns 100000"
        "debug.sf.high_fps_early_gl_phase_offset_ns 9000000"
    )

    success_count=0
    failure_count=0

    for command in "${props[@]}"; do
        setprop $command > /dev/null 2>&1 &
        if [ $? -eq 0 ]; then
            success_count=$((success_count + 1))
        else
            failure_count=$((failure_count + 1))
        fi
    done
(
    settings put global window_animation_scale 0.5
    settings put global transition_animation_scale 0.5
    settings put global animator_duration_scale 0.5
    settings put global always_finish_activities 1
    ) > /dev/null 2>&1 &

}
Dte() {
echo "[ LOG ] Starting X - Boost on:"
echo "  ╰┈➤ $(date)"
}

apply() {
    apply_string > /dev/null 2>&1
    set_system_props
}

echo ""
echo "
                                            ⬛⬛⬛⬛⬛⬛⬛
                                    ⬛⬛⬛⬛⬛⬜⬜⬜⬜⬛
                                  ⬛⬛⬛⬛⬜⬜⬜⬜⬜⬜⬜⬛
                             ⬛⬛⬛⬜⬜⬜⬜⬜⬜⬜⬜⬜⬛⬛
                            ⬛⬛⬛⬜⬜⬜⬛⬛⬜⬜⬜⬜⬜⬛
                         ⬛⬛⬜⬜⬜⬜⬛⬛⬛⬛⬜⬜⬜⬛⬛
                      ⬛⬛⬜⬜⬜⬜⬛⬛🟦🟦⬛⬛⬜⬜⬛⬛
          ⬛⬛⬛⬛⬛⬛⬜⬜⬜⬜⬜⬛⬛🟦🟦⬛⬛⬜⬛⬛
       ⬛⬛⬜⬜⬛⬛⬜⬜⬜⬜⬜⬜⬜⬛⬛⬛⬛⬜⬜⬛⬛
      ⬛⬜⬜⬛⬛⬜⬜⬜⬜⬜⬜⬜⬜⬜⬛⬛⬜⬜⬛⬛
     ⬛⬛⬜⬛⬛⬜⬜⬜⬜⬜⬛⬛⬜⬜⬜⬜⬜⬜⬛⬛
     ⬛⬛⬜⬛⬛⬜⬜⬜⬜⬛⬛⬛⬛⬜⬜⬜⬜⬜⬛⬛
  ⬛⬛⬛⬛⬛⬜⬜⬜⬜⬛⬛⬛⬛⬛⬜⬜⬜⬜⬛⬛
  ⬛⬛⬛⬛⬛⬛⬜⬜⬛⬛⬛⬛⬛⬜⬜⬜⬜⬛⬛
      🟧🟨🟨⬛⬛⬛⬛⬛⬜⬜⬜⬜⬛⬛
    🟧🟧🟨🟨🟨🟨⬛⬛⬛⬛⬜⬜⬜⬜⬛⬛
  🟥🟥🟧🟨🟨🟨🟨⬛⬛⬛⬜⬜⬜⬜⬛⬛⬛
🟧🟥🟥🟥🟧🟨🟨🟨🟨🟨🟨⬜⬜⬛⬛⬜⬛⬛
      🟥🟧🟨🟨🟨🟨🟨🟧⬛⬛⬛⬜⬜⬛⬛
    🟥🟥🟥🟧🟨🟨🟧🟨🟥⬛⬛⬜⬜⬜⬛⬛
  🟥🟥🟥🟥🟧🟧🟥🟧🟨🟥⬛⬛⬛⬛⬛⬛
🟧🟥🟥🟥🟥🟥🟥🟥🟥🟧🟥⬛⬛⬛⬛
🟥      🟥🟥🟥🟧🟥🟧  ⬛⬛
      🟥🟥🟥  🟥🟥
      🟥🟧    🟥🟧
"
echo ""
sleep 1
echo ""
echo "      -ˏˋ⋆ Welcome To Module X - BOOST V5.0 ⋆ˊˎ-"
echo ""
echo ""
sleep 1
echo "》》{ Developer           / @Chermodsc          } 《《"
echo "》》{ My Name Developer  / Aldo                 } 《《"
echo "》》{ Version Module    / 5.0                   } 《《"
echo "》》{ Type Module      / Non Root               } 《《"
echo ""
echo ""
sleep 0.5
echo ""
sleep 1
echo " _  _           ____  _____  _____  ___  ____    ___    ___  "
sleep 1
echo "( \/ )   ___   (  _ \(  _  )(  _  )/ __)(_  _)  | __)  / _ \ "
sleep 1
echo " )  (   (___)   ) _ < )(_)(  )(_)( \__ \  )(    |__ \ ( (_) )"
sleep 1
echo "(_/\_)         (____/(_____)(_____)(___/ (__)   (___/()\___/ "
echo ""
echo ""
Dvice
echo ""
Dte
echo ""
sleep 1
Install
echo ""
sleep 1
echo ""
echo " [ ! ] Total code successfully applied to the game $game_package: $success_count"
sleep 1
echo " [ ! ] Total Failed   : $failure_count"
echo ""
sleep 0.5
echo ""
echo " [INFO] Setting game $game_package FPS to $fps"
sleep 2
echo " [ • ] Open the game $game_package . . . ."
sleep 1
cmd notification post -S bigtext -t 'Enjoyy X - BOOST V5.0🚀' 'tag' "Boost Game - $game_package" > /dev/null 2>&1 &
run_game
fi
fi